import org.camunda.bpm.client.ExternalTaskClient;
import org.camunda.bpm.client.task.ExternalTask;
import org.camunda.bpm.client.task.ExternalTaskHandler;
import org.camunda.bpm.client.task.ExternalTaskService;
import java.util.HashMap;
import java.util.Map;

public class form3_3 {

    public void form3_3Run() {
        System.out.println(this.getClass().getName() + " Started");

        // Initialize the Camunda External Task Client
        ExternalTaskClient client = ExternalTaskClient.create()
                .baseUrl("http://localhost:8080/engine-rest")
                .build();

        // Subscribe to the "Car_Information3" topic
        client.subscribe("Car_Information3")
                .handler(new ExternalTaskHandler() {
                    @Override
                    public void execute(ExternalTask externalTask, ExternalTaskService externalTaskService) {
                        try {
                            // Extract variables from the task
                            String datetime = (String) externalTask.getVariable("datetime");
                            String id = (String) externalTask.getVariable("id");
                            String username = (String) externalTask.getVariable("username");
                            String phonenumber = (String) externalTask.getVariable("phonenumber");
                            String description = (String) externalTask.getVariable("description");
                            String fault_class = (String) externalTask.getVariable("fault_class");

                            // Define the price range based on fault_class
                            String price = "";
                            int earnest_money = 500;  // Set earnest money to 500

                            System.out.println("Ticket details: \n" +
                                    "- DateTime: " + datetime + "\n" +
                                    "- Id: " + id + "\n" +
                                    "- Username: " + username + "\n" +
                                    "- PhoneNumber: " + phonenumber + "\n" +
                                    "- Description: " + description + "\n" +
                                    "- Fault Class: " + fault_class);

                            if ("A".equals(fault_class)) {
                                price = "5000~10000";
                            } else if ("B".equals(fault_class)) {
                                price = "2000~5000";
                            } else {
                                price = "500~2000";
                            }

                            System.out.println("Estimated price range: " + price);
                            System.out.println("Earnest money: " + earnest_money);

                            // Prepare variables for response
                            Map<String, Object> variables = new HashMap<>();
                            variables.put("price", price);
                            variables.put("earnest_money", earnest_money);

                            // Complete the task and set the result variable
                            externalTaskService.complete(externalTask, variables);
                        } catch (Exception e) {
                            System.out.println("Error processing task: " + e.getMessage());
                        }
                    }
                }).open();
    }
}