import org.camunda.bpm.client.ExternalTaskClient;
import org.camunda.bpm.client.task.ExternalTask;
import org.camunda.bpm.client.task.ExternalTaskService;

import java.util.HashMap;
import java.util.Map;

public class form5_4 {

    public void form5_4Run() {
        System.out.println(this.getClass().getName() + " Started");
        // 创建客户端并配置
        ExternalTaskClient client = ExternalTaskClient.create()
                .baseUrl("http://localhost:8080/engine-rest")
                .build();

        // 订阅
        client.subscribe("Car_final_offer_list5")
                .handler((ExternalTask externalTask, ExternalTaskService externalTaskService) -> {

                    // 获取任务变量
                    String datetime = externalTask.getVariable("datetime");
                    String id = externalTask.getVariable("id");
                    String headstock = externalTask.getVariable("headstock");
                    String body = externalTask.getVariable("body");
                    String tailstock = externalTask.getVariable("tailstock");
                    String engine = externalTask.getVariable("engine");
                    String saddle = externalTask.getVariable("saddle");
                    String operating = externalTask.getVariable("operating");
                    String additionalServices = externalTask.getVariable("additional_services");

                    // 定义每个部件的费用
                    Map<String, Integer> priceMapping = Map.of(
                            "good", 0,
                            "normal", 500,
                            "bad", 1000
                    );

                    // 计算总费用
                    int totalCost = 0;
                    totalCost += priceMapping.getOrDefault(headstock, 0);
                    totalCost += priceMapping.getOrDefault(body, 0);
                    totalCost += priceMapping.getOrDefault(tailstock, 0);
                    totalCost += priceMapping.getOrDefault(engine, 0);
                    totalCost += priceMapping.getOrDefault(saddle, 0);
                    totalCost += priceMapping.getOrDefault(operating, 0);

                    // 如果有额外服务，则加上额外费用
                    if ("yes".equals(additionalServices)) {
                        totalCost += 500;  // 假设额外服务增加500元
                    }

                    // 输出日志
                    System.out.println(String.format("Ticket details: \n" +
                                    "- DateTime: %s \n" +
                                    "- Id: %s \n" +
                                    "- Headstock: %s \n" +
                                    "- Body: %s \n" +
                                    "- Tailstock: %s \n" +
                                    "- Engine: %s \n" +
                                    "- Saddle: %s \n" +
                                    "- Operating: %s \n" +
                                    "- Additional Services: %s \n" +
                                    "- Total Maintenance Cost: %d",
                            datetime, id, headstock, body, tailstock, engine, saddle, operating, additionalServices, totalCost));

                    // 设置任务变量并完成任务
                    Map<String, Object> variables = new HashMap<>();
                    variables.put("total_cost", totalCost);

                    externalTaskService.complete(externalTask, variables);
                })
                .open();
    }
}
