import { Client, logger, Variables } from "camunda-external-task-client-js";

// 配置客户端
const config = { baseUrl: "http://localhost:8080/engine-rest", use: logger };

// 创建客户端实例
const client = new Client(config);

// 订阅主题 
client.subscribe("Car_Information3", async function ({ task, taskService }) {

    const variables_ = new Variables();
    const datetime = task.variables.get("datetime");
    const id = task.variables.get("id");
    const username = task.variables.get("username");
    const phonenumber = task.variables.get("phonenumber");
    const description = task.variables.get("description");
    const fault_class = task.variables.get("fault_class");

    let price = "";
    const earnest_money = 500;  // 将定金统一设置为500

    console.log(`Ticket details: 
    - DateTime: ${datetime} 
    - Id: ${id}
    - Username: ${username} 
    - PhoneNumber: ${phonenumber} 
    - Description: ${description} 
    - Fault Class: ${fault_class}`);

    // 根据业务逻辑计算价格区间
    if (fault_class === "A") {
        price = "5000~10000";
    } else if (fault_class === "B") {
        price = "2000~5000";
    } else {
        price = "500~2000";
    }

    // 设置任务变量
    variables_.set("price", price);
    variables_.set("earnest_money", earnest_money);  // 将定金值添加到任务变量中
    variables_.set()

    console.log(`Estimated price range: ${price}`);
    console.log(`Earnest money: ${earnest_money}`);


    // 完成任务
    await taskService.complete(task, variables_);
});
