import { Client, logger, Variables } from "camunda-external-task-client-js";

// 配置客户端
const config = { baseUrl: "http://localhost:8080/engine-rest", use: logger };

// 创建客户端实例
const client = new Client(config);

// 订阅主题
client.subscribe("Car_Issue8", async function ({ task, taskService }) {
    // 获取任务变量
    const datetime = task.variables.get("datetime");
    const name = task.variables.get("name");
    const orderID = task.variables.get("orderID");
    const phonenumber = task.variables.get("phonenumber");
    const feedback = task.variables.get("feedback");

    console.log(`Ticket details: 
    - Datetime: ${datetime} 
    - Name: ${name} 
    - OrderID: ${orderID} 
    - Phone Number: ${phonenumber} 
    - Feedback: ${feedback}`);

    // 完成任务
    await taskService.complete(task);
});