import { Client, logger } from "camunda-external-task-client-js";

// 配置客户端
const config = { baseUrl: "http://localhost:8080/engine-rest", use: logger };

// 创建客户端实例
const client = new Client(config);

// 订阅主题 
client.subscribe("Car_Refund9", async function ({ task, taskService }) {
    
    // 获取任务变量
    const name = task.variables.get("name");
    const phone_number = task.variables.get("phone_number");
    const orderID = task.variables.get("orderID");
    const reason = task.variables.get("reason");

    console.log(`Ticket details: 
    - Name: ${name} 
    - Phone Number: ${phone_number} 
    - OrderID: ${orderID} 
    - Reason: ${reason}`);

    // 完成任务
    await taskService.complete(task);
});

